--
-- Hey there people my fellow data-miners >:3
-- This file is 90% comprised of defining rawsets, objects, sounds, actions, etc; basically everything that is global.
-- Also, it has few important Player, Pre and Post thinkers that run FIRST
--


---------------------------------------------------------------------
------------------------ All freeslot Extra  ------------------------
---------------------------------------------------------------------

-----------------
-------------------------Sprites-------------------------
-----------------
freeslot(

---------------------- 
-------Alt Slots------
----------------------

"SPR2_PONT", "SPR2_POFA", "SPR2_POGR", -- Jazz
"SPR_TRCK", "SPR2_BUSN", "SPR2_BUJU", -- Jazz
"SPR2_F22_", -- Starscream

------------------------
--Transformation Slots--
------------------------

"SPR2_JA_T", "SPR2_T_JA", "SPR2_TFBR", "SPR_POFL", -- Jazz
"SPR2_LEAP",


---------------------- 
-----Weapon Slots-----
----------------------

"SPR_EMPT", "SPR_BLST", "SPR_BULL", -- Jazz
"SPR_WAVE", "SPR_CRCK" -- General
)

-----------------
-------------------------States-------------------------
-----------------
freeslot(

----------------------
----- Bot Slots ------
----------------------

"S_WEAPON_STANCE", "S_CLIMBING", "S_POUND_FALL", "S_POUND_GROUND", -- Jazz
"S_WALL_LEAP", "S_APPEAR",

-----------------
----Alt Slots----
-----------------

"S_F22_MODE", -- Starscream
"S_PONTIAC_MODE", -- Jazz

------------------------
--Transformation Slots--
------------------------

"S_TF_F2_ST", "S_TF_ST_F2",
"S_TF_PON_JA", "S_TF_PON_JA_BR", "S_TF_JA_PON", "S_FLAME_FOLLOW",-- Jazz

------------------------
---------Objects--------
------------------------

"S_ROCKET_EXPLOSION",-- Starscream

"S_BLAST_SHOT", "S_BLAST_EXPLODE", "S_BLAST_DUST", "S_BULL_SHOT", -- Jazz

"S_TRCK", "S_FIRE", "S_EMPTY_MAG_VISUAL", -- Jazz

"S_WAVE_DISTRIBUTE" -- General
)

---------------------- 
-------------------------Sounds-------------------------
----------------------
freeslot("sfx_nil",

----------------------
----- Alt Slots ------
----------------------
"sfx_tfg1", --General
"sfx_jazpon", "sfx_ponjaz", -- Jazz
"sfx_rev", "sfx_idle", "sfx_mid", "sfx_high", "sfx_brake", "sfx_bump", "sfx_horn", -- Jazz
"sfx_whoosh", "sfx_f22eng", "sfx_nitro", -- Starscream
"sfx_f22sta", "sfx_staf22", -- Starscream

----------------------
----- Bot Slots ------
----------------------
"sfx_land_a", "sfx_jump_a", "sfx_clmb_a", "sfx_pogr_a", -- Autobots
"sfx_land_d", "sfx_jump_d", "sfx_clmb_d", -- Decepticons

"sfx_bullet", "sfx_hit", "sfx_miss", "sfx_blast", "sfx_expld", "sfx_blrel", "sfx_burel", "sfx_empty", -- Jazz


------------------------
----- Voice Slots ------
------------------------

"sfx_begn01", "sfx_begn02", "sfx_begn03", "sfx_begn04", "sfx_begn05", -- Jazz
"sfx_win01", "sfx_win02", "sfx_win03", "sfx_win04", "sfx_win05", -- Jazz
"sfx_easy" -- Jazz

)
-----------------
-------------------------Objects-------------------------
-----------------
freeslot(

--------------------------
----- Weapons Slots ------
--------------------------

"MT_WBLS", "MT_WBUL", "MT_EMPT", "MT_POFL", -- Jazz
"MT_STARSCREAM_ROCKET", -- Starscream
"MT_WAVE", "MT_CRCK", -- General

----------------------
----- Alt Slots ------
----------------------

"MT_TRCK", "MT_FIRE", "MT_BDST" -- Car

) 


------------------------------------------------------------------------------------
------------------------ All rawset Variables and Functions ------------------------
------------------------------------------------------------------------------------
--- NOTE: Constant variables are FULLY CAPITALIZED (don't change constants!!!) -----
------------------------------------------------------------------------------------



---Transformer Character Skins
rawset(_G, "SKINS", {JAZZ = "jazz", BARRICADE = "barricade", STARSCREAM = "starscream"})

--- Enums for all possible transformation modes
rawset(_G, "TF_FORM", {
    --- Robot form
    BOT_MODE = 0, 
    --- Vehicle (aka alternative) form
    ALT_MODE = 1,
    --- Process of transforming into the robot form
    TF_TO_BOT_MODE = 2, 
    --- Process of transforming into the vehicle (aka alternative) form
    TF_TO_ALT_MODE = 3
}) 

--- Redesigned Jazz's special ability taken from ROTF game, 
--- passively increasing Jazz's speed under certain circumstances
rawset(_G, "SPECIAL_BOOST",  {
    --- Maximum special boost time by the special ability
    tic_max = 5*TICRATE,
    --- How much tics added to special boost timer when picking up a ring
    ring_tics = 9,
    --- How much tics added to special boost timer when damaging an enemy
    dmg_tics = 25,
    --- How much tics added to special boost timer when damading (or killing?) a monitor
    monitor_tics = 15,
    --- How much tics added to special boost timer when being sprung (aka using a spring)
    spring_tics = 25,
    --- The amount of extra speed in car mode
    bot_speed = FRACUNIT,
    --- The amount of extra acceleration in bot mode
    bot_accel = 25,
    --- The amount of extra speed in car mode
    car_speed = 10*FRACUNIT,
    --- The amount of extra acceleration in car mode
    car_accel = FRACUNIT
})

rawset(_G, "PONTIAC_POWERUP_FLAGS", STR_BUST|STR_SPIKE)
--Voice related
rawset(_G, "VOICE_VOLUME", 255)
rawset(_G, "BEGN_TICS_MAX", TICRATE/2)

----------------------------------------------------------
--------------- Bot Mode Raw-set Constants ---------------
----------------------------------------------------------

---Ground pound power flags 
rawset(_G, "POUND_FLAGS", STR_SPRING|STR_HEAVY|STR_FLOOR|STR_CEILING|STR_GUARD)
--- At what minimum speed will Jazz be able to break walls, ceiling, floors, and empower springs
rawset(_G, "BREAK_SPEED", 35*FRACUNIT)

--Defines the wheel grip car has over the ground
--In-Control: The car is on the ground under perfect circumstances: best control
--Oversteer: The car turned over the limit, player can take advantage to drift: medium control
--No-control The car is either airbone or in low friction area, worst control
rawset(_G, "CAR_TRACTION", {IN_CONTROL = 0, OVERSTEER_CONTROL = 1, NO_CONTROL = 2}) 

--The maximum FRACUNIT angle difference between actual movement angle and movement of the tires, after which oversteering is occuring
rawset(_G, "GRIP_LIMIT", 40*FRACUNIT)  

--Simulating the gear
rawset(_G, "GEAR_MODE", {DRIVE = 0, REVERSE = 2, PARK = 3})


--Sound related
rawset(_G, "MAX_IDLE_SOUND_TICS", 34)
rawset(_G, "MAX_MID_SOUND_TICS", 47)
rawset(_G, "MAX_HIGH_SOUND_TICS", 26)


--Bumping objects out of hte way
rawset(_G, "BUMP_MF", MF_ENEMY|MF_MONITOR) --Objects that are able to be bumped
rawset(_G, "BUMP_NOT_MF", 0) -- Not used, but intended to detect objects that can't be bumped
rawset(_G, "BUMP_SPEED", 2*FRACUNIT) --At what speed car mode can bump objects

--Misc
rawset(_G, "CAR_SHIELD_SCALE", FRACUNIT)

-- A cooldown of tranformation.
rawset(_G, "TF_TIMER_MAX", 20*TICRATE)
-- Maximum fuel for jet mode
rawset(_G, "FUEL_CAP", 500*FRACUNIT)
-- Cool down of the missle show
rawset(_G, "MISSILE_TIMER_MAX", 50*TICRATE)

-- Maximum distance between missile and enemy at which lock-on will begin 
rawset(_G, "MISSLE_LOCK_DISTANCE", 100*FRACUNIT)


----------------------------------------------------------
--------------- Bot Mode Raw-set Constants ---------------
----------------------------------------------------------


--Weapons
rawset(_G, "BURST_SHOT_INTERVAL_TIC_MAX", 10) --Total period of bullets being shot (not every tic of it)
rawset(_G, "BLAST_KNOCKBACK", 20*FRACUNIT)

rawset(_G, "CRESCENT_MAG_MAX", 1) --Amounts of shots left before empty
rawset(_G, "SLUG_MAG_MAX", 9) --Amounts of shots left before empty
rawset(_G, "SLUG_RELOAD_TICS_MAX", 1*TICRATE) --Reload time for the bullet weapon
rawset(_G, "CRESCENT_RELOAD_TICS_MAX", 2*TICRATE) --Reload time for the blast weapon
rawset(_G, "CRESCENT_RING_REQUIREMENT", 5) --Required amount of rings to possed in order to use the gun

--Transformation into bot
rawset(_G, "TO_BOT_JUMP", FRACUNIT*10) --Jump force applied whlie transforming into bot 

--Climbing (maybe deprecated)
rawset(_G, "CLIMB_WALL_DISTANCE", 30*FRACUNIT) --
rawset(_G, "CLIMBING_SPEED", 5*FRACUNIT) --Speed of climbing all four directions


--------------------------------------------------------
--------------- Rawset functions -----------------------
--------------------------------------------------------

-- CV_RegisterVar({
--     name = "tf_classic",
--     defaultvalue = "0", -- or "sound1"
--     flags = CV_CALL|CV_SAVE,
--     PossibleValue = CV_OnOff,
--     func = function(v)
--         CONS_Printf("Sound option set to: " + v.value, )
--     end
-- })

-- COM_AddCommand("tf_classic", function(player, arg1)
--     local help = "Would you like to use classic G1 transformation sound? \n tf_classic: {option}\n Options: 0 - Default ; 1 - Classic G1"
--     if(arg1 == nil) then
--         print(help)
--     elseif(arg1 == "0") then
--         player.tf_sound = false
--         print("Switching to default transformation sound...")
--     elseif(arg1 == "1") then
--         player.x _sound = true
--         print("Switching to classic transformation sound...")
--     else
--         print("Use correct numbers!\n"+help)
--     end
-- end, COM_LOCAL)

--Clamps the integer num between inlcusive bounds
rawset(_G, "clamp", function(num, lower, upper)
	if(num > upper) then
		num = upper
	elseif(num < lower) then
		num = lower
	end
	return num
	-- return max(lower, min(upper, num))
end)


--Checks whether the mobject is valid and (optionally) has the correct skin 
rawset(_G, "Valid", function(mo, skin)
	return mo ~= nil and mo.valid == true and mo.skin == skin and mo.state ~= S_NULL--and mo.state ~= states[mo.state].deathstate
end)

--Return true if given mobject is one of the transformer characters and VALID
rawset(_G, "TransformCharacter", function(mo)
	for index, skin in pairs(SKINS) do
        if(Valid(mo, skin)) then
            return true
        end
    end
    return false
end)

--Checks whether the mobject is alive, not leaving the level, not being damaged
rawset(_G, "Active", function(player)
	return (player.playerstate == PST_LIVE and player.exiting == 0 and player.mo.state ~= mobjinfo[player.mo.type].painstate)
end)

--Gets the actual absolute speed in 3D space at any angle
rawset(_G, "GetRealSpeed", function(player)
    local vs = abs(player.mo.momz) -- Vertical speed
    local hs = player.speed -- Horizontal speed
	return FixedSqrt(FixedMul(vs, vs) + FixedMul(hs, hs))
	-- return max(lower, min(upper, num))
end)


--Function mostly shown by clairebun to use on SRB2 discord page
--mo1 (mobj_t): first mobj to check for collision
--mo2 (mobj_t): second mobj to check for collision
--extraheight (int): extra height added to the mo2
--returns: true if two mobjects collide vertically, false otherwise
rawset(_G, "L_ZCollide", function(mo1, mo2, extraheight)
	if(extraheight == nil) then
		extraheight = 0
	end
    if mo1.z > mo2.height+mo2.z+extraheight then return false end
    if mo2.z > mo1.height+mo1.z then return false end
    return true
end)

-- --Spawns the objects on the side of the player
-- --Returns right and left spawned objects
-- rawset(_G, "SpawnOnSide", function(player, toSpawn, forward_offset)
--     if (forward_offset == nil) then
--         forward_offset = 0
--     end

--     local right_x = player.mo.x + forward_offset + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(cos(player.mo.angle+ANGLE_90)), player.mo.scale)) 
--     local right_y = player.mo.y + forward_offset + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(sin(player.mo.angle+ANGLE_90)), player.mo.scale)) 
--     local left_x  = player.mo.x + forward_offset + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(cos(player.mo.angle-ANGLE_90)), player.mo.scale))
--     local left_y  = player.mo.y + forward_offset + FixedMul(skins[player.mo.skin].radius, FixedMul(InvAngle(sin(player.mo.angle-ANGLE_90)), player.mo.scale)) 
    
--     local z = player.mo.z
--     if(player.mo.eflags & MFE_VERTICALFLIP) then
--         z = $ + player.mo.height - mobjinfo[toSpawn].height
--     end

--     --Spawn at the side
--     local right = P_SpawnMobj(right_x, right_y, z, toSpawn)
--     local left = P_SpawnMobj(left_x, left_y, z, toSpawn)

--     right.scale = player.mo.scale
--     left.scale = player.mo.scale

--     return right, left
-- end)


local function SpawnOnSide(player, toSpawn, forward_offset)
    if not player or not player.mo then return end

    if forward_offset == nil then
        forward_offset = 0
    end

    local angle = player.mo.angle
    local radius = FixedMul(skins[player.mo.skin].radius, player.mo.scale)

    -- Forward offset calculation based on angle
    local forward_x = FixedMul(forward_offset, cos(angle))
    local forward_y = FixedMul(forward_offset, sin(angle))

    -- Right and left offset angles
    local right_angle = angle + ANGLE_90
    local left_angle = angle - ANGLE_90

    -- Side offset calculations
    local side_x_offset = FixedMul(radius, cos(right_angle))
    local side_y_offset = FixedMul(radius, sin(right_angle))

    -- Right spawn position
    local right_x = player.mo.x + forward_x + side_x_offset
    local right_y = player.mo.y + forward_y + side_y_offset

    -- Left spawn position (just flip the side offset)
    local left_x = player.mo.x + forward_x - side_x_offset
    local left_y = player.mo.y + forward_y - side_y_offset

    local z = player.mo.z
    if player.mo.eflags & MFE_VERTICALFLIP then
        z = $ + player.mo.height - mobjinfo[toSpawn].height
    end

    -- Spawn the objects
    local right = P_SpawnMobj(right_x, right_y, z, toSpawn)
    local left = P_SpawnMobj(left_x, left_y, z, toSpawn)

    right.scale = player.mo.scale
    left.scale = player.mo.scale

    if(right.valid == true and not P_IsObjectOnGround(right)) then
        P_KillMobj(right)
    end
    if(left.valid == true and not P_IsObjectOnGround(left)) then
        P_KillMobj(left)
    end

    return right, left
end

local function SwitchTo(player)
    -- if(Valid(player.mo, SKINS.JAZZ)) then
    -- 	return false -- do not switch to jazz if the player is already jazz
    -- end

    -- player.mo.flags = $|MF_SLIDEME


    --Set controls
    player.jumpheld = 0
    player.spinheld = 0
    player.forwardheld = 0
    player.prevjumpheld = 0
    player.prevspinheld = 0
    player.mo.prevtics = 0
    player.mo.prevframemask = 0
    player.mo.prevleftheld = 0

    player.mo.prevstate = player.mo.state
    
    --The previous vertical momentum
    player.mo.prevmomz = 0
    
    --Is jump special available?
    player.jumpspecial = 0 -- true if releasing jump in the air, enable implementing jumping special abilities manual
    player.special = nil
    player.specialUsed = nil

    --The current transformation mode of jazz
    if(player.tf_form == nil) then
        player.tf_form = TF_FORM.BOT_MODE -- The default jazz mode is botmode
    end
    -- player.tf_classic_sound = false
    player.in_tf_tics = 0 
    player.burst_shot_interval_tics = 0 --Current bullet tic countdown


    player.crescent_mag = CRESCENT_MAG_MAX -- Shots left in the mag
    player.slug_mag = SLUG_MAG_MAX -- Shots left in the mag
    player.crescent_reload_tics = CRESCENT_RELOAD_TICS_MAX --How long it takes to reload
    player.slug_reload_tics = SLUG_RELOAD_TICS_MAX --How long it takes to reload

    player.mo.fuel_countdown = 0
    player.mo.missile_countdown = nil

    player.special_boost_tics = 0 -- Current tic countdown, applying special speed boost while tic counter is above 0

    player.sfx_begn_tics = -1 -- Voiceline countdown, executes only when equal 0
    player.sound_tics_idle = MAX_IDLE_SOUND_TICS --Sound countdowns
    player.sound_tics_mid = MAX_MID_SOUND_TICS --Sound countdowns
    player.sound_tics_high = MAX_HIGH_SOUND_TICS --Sound countdowns
    
    player.mo.car_traction = CAR_TRACTION.NO_CONTROL
    player.mo.car_gear = GEAR_MODE.PARK
    player.mo.car_accel = 0 --Speed applied every tic
    player.mo.car_forward_angle = player.mo.angle --What is the movement (forward or front) angle of the car
    player.car_steer_input = 0 --Player's input on the steering buttons, between -1000 and 1000
    player.car_gas_input = 0 --Player's input on the gas button, between 0 and 1
    player.car_brake_input = 0 --Player's input on the brake button, between 0 and 1

    -- True if the jazz was on the ground in the previous frame
    player.mo.car_prevground = true

    --List of bosses found on this level
    player.bosses_detected = {}

    return true
end

local function SwitchOff(player)
	-- if(Valid(player.mo)) then
		-- return false
	-- end

    if(player.tf_form == TF_FORM.ALT_MODE) then
        player.mo.state = S_TF_PON_JA
    end

    -- --Remove controls
	-- player.jumpheld = nil
	-- player.spinheld = nil
    -- player.forwardheld = nil
	-- player.prevjumpheld = nil
	-- player.prevspinheld = nil

	-- player.mo.prevmomz = nil
	-- player.jumpspecial = nil

    -- -- player.tf_form = nil
    -- -- player.in_tf_tics = nil
    
    -- player.mo.steering = nil

    -- player.mo.car_accel = nil
    -- player.mo.applied_angle = nil
    -- player.forward_input = nil
    -- player.braking_input = nil

    -- player.mo.car_prevground = nil
    -- player.mo.prevskin = nil

    return true
end

--NOTE: Original code was refactored by ChatGPT
-- Spawns the objects on the side of the player
-- Returns right and left spawned objects
rawset(_G, "SpawnOnSide", SpawnOnSide)

--Switch off the jazz skin
--Returns true if could switch offset jazz, false if player wan't jazz in the first place
rawset(_G, "SwichOff", SwitchOff)

--Switch to the jazz skin
--Returns true if could switch to jazz, false if player was already it
rawset(_G, "SwitchTo", SwitchTo)

--Adds time to the special boost ability
rawset(_G, "AddSpecialBoostTics", function(player, tics)
    if(player.special_boost_tics == nil) then
        player.special_boost_tics = 0
    end
    player.special_boost_tics = clamp($ + tics, 0, SPECIAL_BOOST.tic_max) 
end)

--------------------------------------------------------
--------------- Non-rawset functions -------------------
--------------------------------------------------------

local function ReloadThink(player)
    --Try reloading the Slug Repeater (bullet weapon)
    if(player.slug_mag <= 0) then -- If slug has no ammo
        --Timers
        if(player.slug_reload_tics <= 0) then --Has reload timer ran out?
            player.slug_mag = SLUG_MAG_MAX --Fully reload
            player.slug_reload_tics = SLUG_RELOAD_TICS_MAX --reset timer
            S_StartSound(player.mo, sfx_burel)
        else --Reload timer has to keep going
            --Count down time until reload
            player.slug_reload_tics = $-1
        end
        
    end
    --Try reloading the Crescent Blaster (blast weapon)
    if(player.crescent_mag <= 0) then -- If crescent has no ammo
        --Timers
        if(player.crescent_reload_tics <= 0) then --Has reload timer ran out?
            player.crescent_mag = CRESCENT_MAG_MAX --Fully reload
            player.crescent_reload_tics = CRESCENT_RELOAD_TICS_MAX --reset timer
            S_StartSound(player.mo, sfx_blrel)
        else --Reload timer has to keep going
            --Count down time until reload
            player.crescent_reload_tics = $-1
        end
        
    end

end


------------------------------------------------------------
------------------ All Sound definitions -------------------
------------------------------------------------------------


------------------------------ Transformation sounds
-- Classic g1 transformation sound
sfxinfo[sfx_tfg1] = {
	singular = false,
	priority = 64
}

-- Transformion to car
sfxinfo[sfx_jazpon] = {
	singular = false,
	priority = 64
}

-- Transformion to bot
sfxinfo[sfx_ponjaz] = {
	singular = false,
	priority = 64
}
------------------------------ Car sounds
-- Starting the engine
sfxinfo[sfx_rev] = {
	singular = false,
	priority = 65
}
-- No movement
sfxinfo[sfx_idle] = {
	singular = false,
	priority = 65
}
-- Medium speed
sfxinfo[sfx_mid] = {
	singular = false,
	priority = 65
}

-- High to max speed
sfxinfo[sfx_high] = {
	singular = false,
	priority = 65
}
-- Braking sound
sfxinfo[sfx_brake] = {
    singular = false,
	priority = 64
}
-- Bumping sound
sfxinfo[sfx_bump] = {
    singular = false,
	priority = 64
}
-- Horn sound
sfxinfo[sfx_horn] = {
    singular = false,
	priority = 66
}
------------------------------ Bot sounds
-- Sound of slug bullet firing
sfxinfo[sfx_bullet] = {
	singular = false,
	priority = 64
}
-- Sound of bullet hitting an enemy with a bullet
sfxinfo[sfx_hit] = {
	singular = false,
	priority = 64
}
-- Sound of bullet hitting a wall with a bullet
sfxinfo[sfx_miss] = {
    singular = false,
	priority = 64
}
--Sounds of crescent blast firing 
sfxinfo[sfx_blast] = {
    singular = false,
	priority = 64
}
sfxinfo[sfx_expld] = {
    singular = false,
	priority = 64
}
--Ground pound
sfxinfo[sfx_pogr_a] = {
    singular = false,
	priority = 65
}
-- Autobot landing on the ground
sfxinfo[sfx_land_a] = {
	singular = false,
	priority = 64
}
-- Decepticon of landing on the ground
sfxinfo[sfx_land_d] = {
	singular = false,
	priority = 64
}
--Autobot jumping
sfxinfo[sfx_jump_a] = {
	singular = false,
	priority = 64,
	flags = SF_TOTALLYSINGLE--|SF_X4AWAYSOUND
}
--Decepticon jumping
sfxinfo[sfx_jump_d] = {
	singular = false,
	priority = 64,
	flags = SF_TOTALLYSINGLE--|SF_X4AWAYSOUND
}
-- Autobot climbing on the wall
sfxinfo[sfx_clmb_a] = {
	singular = false,
	priority = 64
}
-- Decepticon climbing on the wall
sfxinfo[sfx_clmb_d] = {
	singular = false,
	priority = 64
}
--Sounds of trying to use a weapon with empty mag
sfxinfo[sfx_empty] = {
	singular = false,
	priority = 64
}
-- Sound of reloading the Crescent Blaster blast weapon
sfxinfo[sfx_blrel] = {
	singular = false,
	priority = 64
}
-- Sound of reloading the Slug Repeater bullet weapon
sfxinfo[sfx_burel] = {
	singular = false,
	priority = 64
}

--Sound played when transforming into bot
sfxinfo[sfx_f22sta] = {
	singular = false,
	priority = 64
	-- flags = SF_TOTALLYSINGLE
}
--Sound played when transforming into bot
sfxinfo[sfx_staf22] = {
	singular = false,
	priority = 64,
	flags = SF_TOTALLYSINGLE
}
--Constant sound during jet mode
sfxinfo[sfx_whoosh] = {
	singular = false,
	priority = 64,
	flags = SF_X4AWAYSOUND
}
--Constant sound during jet mode
sfxinfo[sfx_f22eng] = {
	singular = false,
	priority = 64,
	flags = SF_X4AWAYSOUND
}
--Constant sound during jet mode
sfxinfo[sfx_nitro] = {
	singular = true,
	priority = 64,
	flags = SF_X4AWAYSOUND
}
------------------------------ Voicelines sounds
--Played during getting a level-up and related actions
sfxinfo[sfx_easy] = {
    singular = false,
    priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn01] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn02] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn03] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn04] = {
    singular = false,
	priority = 64
}
--Starting a boss fight
sfxinfo[sfx_begn05] = {
    singular = false,
	priority = 64
}
--Winning a boss fight
sfxinfo[sfx_win01] = {
    singular = false,
	priority = 64
}
--Winning a boss fight
sfxinfo[sfx_win02] = {
    singular = false,
	priority = 64
}
--Winning a boss fight
sfxinfo[sfx_win03] = {
    singular = false,
	priority = 64
}

--Winning a boss fight
sfxinfo[sfx_win04] = {
    singular = false,
	priority = 64
}

--Winning a boss fight
sfxinfo[sfx_win05] = {
    singular = false,
	priority = 64
}
--------------------------------------------------------------------
------------------------ Important Thinkers ------------------------
--------------------------------------------------------------------


--The Base Thinker that plays before others,
--Mostly used to record players input
addHook("PreThinkFrame", function()
	for player in players.iterate() do
        
        -- print("S: "..player.mo.skin)
        -- print("P: "..player.mo.prevskin)

        if(player.mo.prevskin ~= player.mo.skin) then
            --Skin switching behavior
            if(player.mo.prevskin == SKINS.JAZZ) then
                SwichOff(player)
            elseif(player.mo.skin == SKINS.JAZZ or player.mo.prevskin == nil) then
                SwitchTo(player)
            end
        end

        -- print("PS: "..player.mo.skin)
        -- print("PP: "..player.mo.prevskin)
        
        
        --Prevent any non-jazz players to execute behavior afte rit
        -- continue -- Try find the next jazz player if current is not jazz
        -- if(player.mo.skin == SKINS.JAZZ) then
        if(TransformCharacter(player.mo)) then


            --Stop falling animation on last 
            if(player.mo.state == S_PLAY_FALL) then
                if(player.mo.frame & FF_FRAMEMASK == C) then
                    player.mo.frame = $
                    player.mo.tics = -1
                end
            end
        
            -- Prevent drowning in liquid and suffocating in space
            player.powers[pw_underwater] = 0
            player.powers[pw_spacetime] = 0

            -- Controls 
            --Jump button
            if(player.cmd.buttons & BT_JUMP) then
                player.jumpheld = $+1
            else
                player.jumpheld = 0
            end

            --Spin button
            if(player.cmd.buttons & BT_SPIN) then
                player.spinheld = $+1
            else
                player.spinheld = 0
            end

            --Forward button (accounting for joystick too)
            if(player.cmd.forwardmove >= 40) then
                player.forwardheld = $+1
            else
                player.forwardheld = 0
            end

            --Jump special ability (available when letting go of jump button in the air)
            if(player.climbing == 0 and 
            (player.powers[pw_justsprung] ~= 0 or 
            (not P_IsObjectOnGround(player.mo) and player.jumpheld == 0 and player.pflags&PF_JUMPED))) then
                player.jumpspecial = 1
            elseif(player.mo.eflags & MFE_JUSTHITFLOOR or player.powers[pw_carry] ~= 0) then
                player.jumpspecial = 0
            end

        end
    end
end)





-- Regular behaviors for both modes (such as Passive Skills)
addHook("PlayerThink", function(player)
    
    if(not TransformCharacter(player.mo)) then
        return 
    end

    if(player.special_boost_tics > 0) then --Special speed boost is in the affect
        player.special_boost_tics = $-1 --Counting down special speed boost timer
    end


    --Reload the weapons if needed
    ReloadThink(player)
    

    --Add special time if using a spring
    if(player.powers[pw_justsprung] ~= 0) then
        AddSpecialBoostTics(player, SPECIAL_BOOST.spring_tics)
    end
    
    local radius = 1000*FRACUNIT

    --Find boss nearby
    searchBlockmap("objects", function(jazzmo, foundmo)
        if(foundmo.valid and foundmo.flags & MF_BOSS == 0) then
            return -- Stop if boss is not actually a boss
        end
        --Make sure that this boss wasn't detected
        for index, boss in ipairs(jazzmo.player.bosses_detected) do
            if boss == foundmo then
                return true
            end
        end
        --Add the boss to the list of detected bossed on this level
        table.insert(jazzmo.player.bosses_detected, foundmo)
        --Start the countdown that will trigger the voiceline
        if(player.sfx_begn_tics < 0) then
            player.sfx_begn_tics = BEGN_TICS_MAX
        end
    end, player.mo,player.mo.x-radius, player.mo.x+radius, player.mo.y-radius, player.mo.y+radius)

    --Play the sound if the timer ended
    if(player.sfx_begn_tics == 0) then
        S_StartSound(player.mo, P_RandomRange(sfx_begn01,sfx_begn05)) --Play sound when found 
    end
    --Keep counting down the voiceline timer
    if(player.sfx_begn_tics >= 0) then
        player.sfx_begn_tics = $-1
    end


end)


local function KeepState(player, state_num)
    
end


--The Thinker that plays after other thikers,
--mostly used to clean up, record the previous state, 
--and jump and spin button holding
addHook("PostThinkFrame", function()
	for player in players.iterate() do
        
		if(TransformCharacter(player.mo)) then

            -- Prevent changing states
            if(player.mo.prevstate == S_TF_JA_PON and player.mo.eflags & MFE_JUSTHITFLOOR) then
                player.mo.state = S_TF_JA_PON
                player.mo.tics = player.mo.prevtics
                player.mo.frame = $&~FF_FRAMEMASK|player.mo.prevframemask
            end

            -- Remove empowered string after the pound fall
            if(player.mo.prevstate == S_POUND_FALL and player.mo.state ~= S_POUND_FALL) then
                player.powers[pw_strong] = $&~POUND_FLAGS
            end

            --Chaning fall pound to ground pound 
            if(player.mo.prevstate == S_POUND_FALL and player.mo.state ~= S_POUND_FALL 
            and player.mo.eflags & MFE_JUSTHITFLOOR ~= 0
            and player.powers[pw_strong]&MF_SPRING == 0) then
                player.mo.state = S_POUND_GROUND
            end

            --Keep being in car state

            if(player.tf_form == TF_FORM.ALT_MODE) then
                -- Jazz
                if(player.mo.skin == SKINS.JAZZ and player.mo.state ~= S_TF_PON_JA and player.mo.state ~= S_TF_JA_PON) then
                    player.mo.state = S_PONTIAC_MODE
                -- Starscream
                elseif(player.mo.skin == SKINS.STARSCREAM and player.mo.state ~= S_TF_F2_ST and player.mo.state ~= S_TF_ST_F2) then
                    player.mo.state = S_F22_MODE
                end
            end

            --Keep being in breakdancing state when landing
            if(player.mo.state ~= S_TF_PON_JA_BR and player.mo.prevstate == S_TF_PON_JA_BR and (player.mo.eflags & MFE_JUSTHITFLOOR or (player.jumpheld < 5 and player.jumpheld > 0))) then
                player.mo.state = S_TF_PON_JA_BR
            end
            
            --Keep player in shooting stance when landing 
            if(player.mo.prevstate == S_WEAPON_STANCE and player.mo.eflags & MFE_JUSTHITFLOOR)then
                player.mo.state = S_WEAPON_STANCE
            end        
            
            player.prevjumpheld = player.jumpheld
            player.prevspinheld = player.spinheld
            
            player.mo.prevstate = player.mo.state
            player.mo.prevtics = player.mo.tics
            player.mo.prevframemask = player.mo.frame & FF_FRAMEMASK
            
            --Recording if the car was on the ground in previous tic
            player.mo.car_prevground = P_IsObjectOnGround(player.mo)
		end

        player.mo.prevskin = player.mo.skin

	end
end)

---If the Wave object collides with the object after ground pound, affect it!
---@param mo mobj_t
---@param collide_mo mobj_t
addHook("MobjMoveCollide", function(mo, collide_mo)
    if(mo.target ~= collide_mo and L_ZCollide(mo, collide_mo)) then
        if(collide_mo.flags&MF_ENEMY) then
            P_SetObjectMomZ(collide_mo, 10*FRACUNIT, false)
            P_InstaThrust(collide_mo, mo.angle, 20*FRACUNIT)
        elseif(collide_mo.flags&MF_MONITOR
                or collide_mo.type == MT_SPIKE) then
            P_KillMobj(collide_mo, mo, mo.target)
        end
        AddSpecialBoostTics(mo.target.player, SPECIAL_BOOST.dmg_tics)
    end
end, MT_WAVE)


addHook("MobjDamage", function(target, inflictor, source, damagetype)

    if(not TransformCharacter(source)) then
        return --Target wasn't killed by Transformer
    end

    --Jazz killed the enemy
    if(target.flags & MF_ENEMY) then
        AddSpecialBoostTics(source.player, SPECIAL_BOOST.dmg_tics)
    end

end)


addHook("MobjDeath", function(target, inflictor, source, damagetype)

    if(not TransformCharacter(source) or not target.valid) then --Target wasn't killed by Transformer
        return 
    end

    if(target.flags & MF_BOSS ~= 0) then --Jazz killed the boss
        --Play sound
        S_StartSound(source, P_RandomRange(sfx_win01,sfx_win05))
    elseif(target.type == MT_RING) then --Jazz collected a ring
        --Adding tics to the boost timer, making sure it doesn't go aboe the limit
        AddSpecialBoostTics(source.player, SPECIAL_BOOST.ring_tics)
    elseif(target.flags & MF_MONITOR) then --Jazz collected a ring
        if(target.type == MT_1UP_BOX) then
            S_StartSound(source.mo, sfx_easy)
        end
        --Adding tics to the boost timer, making sure it doesn't go aboe the limit
        AddSpecialBoostTics(source.player, SPECIAL_BOOST.monitor_tics)
    end
end)


-------------------------------------------------------------
------------------------ All Actions ------------------------
-------------------------------------------------------------

local function A_BLAST_EXPLODE(blast, var1, var2)
    --Explosion effect
    blast.destscale = 5*FRACUNIT
    blast.scalespeed = 2*FRACUNIT
    blast.spriteyoffset = $ - (blast.height/2)
    states[blast.state].frame = FF_TRANS10
    
    local dust = P_SpawnMobjFromMobj(blast, 0, 0, 0, MT_TNTDUST)
    -- dust.destscale = blast.destscale * 2
    -- dust.scalespeed = blast.scalespeed * 2


    local search_radius = 1000*FRACUNIT
    local max_distance = FixedMul(blast.radius , blast.destscale)
    local max_height = FixedMul(blast.height , blast.destscale)

    --Find the enemy to hit on the explosion 
    searchBlockmap("objects", function(blastmo, foundmo)

        
        local distance = R_PointToDist2(blastmo.x, blastmo.y, foundmo.x, foundmo.y)
        local height = max(abs(blastmo.z - foundmo.z), abs(foundmo.z - blastmo.z))
        if(foundmo.valid and foundmo.flags & MF_SHOOTABLE|MF_SOLID ~= 0 --Correct flags and validity
        and distance <= max_distance and height <= max_height --Check horizontal and height distances
        and P_CheckSight(blastmo, foundmo) and foundmo.state ~= mobjinfo[foundmo.type].painstate) then
            
            if(blastmo.target == foundmo) then -- Self-damage
                P_DamageMobj(foundmo) 
                P_Thrust(foundmo, R_PointToAngle2(blastmo.x, blastmo.y, foundmo.x, foundmo.y), BLAST_KNOCKBACK)
            else -- Damaging the enemy
                P_DamageMobj(foundmo, blastmo, blastmo.target, blastmo.damage)
            end
        end
    end, blast, blast.x-search_radius, blast.x+search_radius, blast.y-search_radius, blast.y+search_radius)
end

local function A_BLAST_SHOT(blast, var1, var2)
    -- print(blast.info.damage)

end


local function A_BULLET_STANCE(actor, var1, var2)
    if(not TransformCharacter(actor)) then
        return false --Wasn't called for jazz
    end

    -- actor.player.burst_shot_interval_tics = BURST_SHOT_INTERVAL_TIC_MAX
end

--Start climbing
local function A_CLIMBING(actor, var1, var2) 
    if(not TransformCharacter(actor)) then
        return false --Wasn't called for jazz
    end
end


-- Sets up jazz for transformation into the bot
local function A_TF_PON_JA(actor, var1, var2)

    if(not TransformCharacter(actor)) then
        return false
    end
    
    --- Was the fire button pressed?
    local fire_button = nil

    --Start skidding for car momentum
    actor.player.charflags = $&~SF_NOSKID
    actor.player.powers[pw_strong] = $&~STR_HEAVY&~PONTIAC_POWERUP_FLAGS


    --Transformation sound
    if(not S_SoundPlaying(actor, sfx_ponjaz)) then
        -- Play sound
        S_StartSound(actor, sfx_ponjaz)
    end

    -- Stop car sounds
    S_StopSoundByID(actor, sfx_brake)
    S_StopSoundByID(actor, sfx_rev)
    S_StopSoundByID(actor, sfx_idle)
    S_StopSoundByID(actor, sfx_mid)
    S_StopSoundByID(actor, sfx_high)
    if(actor.player.follower ~= nil and actor.player.follower.valid) then
        P_KillMobj(actor.player.follower, nil, nil)
    end

    -- Is pressing fire?		
    if(actor.player == secondarydisplayplayer) then
        fire_button = input.gameControl2Down(GC_FIRE)
    else
        fire_button = input.gameControlDown(GC_FIRE)
    end

    -- Artificial jump while transforming
    if((actor.player.jumpheld >= 1 or fire_button ~= 0) and P_IsObjectOnGround(actor) and actor.eflags & MFE_UNDERWATER == 0) then
        P_SetObjectMomZ(actor, TO_BOT_JUMP, true)
        actor.player.pflags = $|PF_JUMPED
        actor.player.jumpspecial = 1 -- Count as a jump
    --Play jumping animation (this is default, so it might be applied again somewhere else)
    --    states[actor.state].nextstate = S_PLAY_JUMP
    end
end

local function A_TF_PON_JA_BR(actor, var1, var2)
    
end


-- Sets up jazz for transformation into the car
local function A_TF_JA_PON(actor, var1, var2)
    if(not TransformCharacter(actor)) then
        return 
    end

    
    -- Reduce the height of car to fit into the spingap
    actor.player.height = actor.player.spinheight
    actor.player.shieldscale = CAR_SHIELD_SCALE

    --Restore angles and flags
    actor.car_forward_angle = actor.angle
    actor.player.charflags = $|SF_NOSKID
    actor.player.powers[pw_strong] = $|STR_HEAVY

    -- Play sound
    if(not S_SoundPlaying(actor, sfx_jazpon)) then
        S_StartSound(actor, sfx_jazpon)
    end
end




-- Sets up Starscream for transformation into the jet
local function A_TF_F2_ST(actor, var1, var2)
    
	actor.player.powers[pw_strong] = $|STR_BUST|STR_SPRING
	actor.flags = $&~MF_NOGRAVITY
    -- actor.momx = $/2
    -- actor.momy = $/2
    -- actor.momz = $/2
    P_SetObjectMomZ(actor, -5*FRACUNIT, true)
	actor.rollangle = 0
	
    --Stop the alt sounds
    S_StopSoundByID(actor, sfx_whoosh)
    S_StopSoundByID(actor, sfx_f22eng)
    -- S_StartSound(actor, sfx)
	-- Play transformation sound if applicable
	if(not S_SoundPlaying(actor, sfx_f22sta)) then
		S_StartSound(actor, sfx_f22sta)
	end
    
end 


-- Sets up Starscream for transformation from the jet
local function A_TF_ST_F2(actor, var1, var2)
	
	actor.player.powers[pw_strong] = $&~STR_BUST&~STR_SPRING
	-- player.mo.height = skins[player.mo.skin].height/2
	actor.player.height = actor.player.spinheight
    actor.flags = $|MF_NOGRAVITY
    P_SetObjectMomZ(actor, -actor.momz/2, true)
    actor.fuel_countdown = FUEL_CAP
    
    if(not S_SoundPlaying(actor, sfx_staf22)) then
	    S_StartSound(actor, sfx_staf22)
    end
end


local function A_POUND_FALL(actor, var1, var2)
    P_SetObjectMomZ(actor, var1, true)
    actor.player.powers[pw_strong] = $|POUND_FLAGS
    actor.momx = $/2
    actor.momy = $/2
end


local function A_POUND_GROUND(actor, var1, var2)
    -- There angle at whih the current wave object is launched
    local cur_angle = actor.angle
    -- How many wave objects will be spawned
    local max_waves = 15
    local angle_shift = (360/max_waves)*ANG1
    for i = 1, max_waves, 1 do
        local wave_mt = P_SpawnMobjFromMobj(actor, 0, 0, 0, MT_WAVE)
        wave_mt.target = actor
        wave_mt.angle = cur_angle
        wave_mt.spritexscale = $*5
        P_Thrust(wave_mt, cur_angle, 50*FRACUNIT)
        cur_angle = $ + angle_shift
    end

    S_StartSoundAtVolume(actr, sfx_pogr_a, 255)
    -- S_StartSound(actor, sfx_pogr_a)
    -- actor.momx = $/2
    -- actor.momy = $/2
end

local function A_WAVE_DISTRIBUTE(actor, var1, var2)
    
    
    
end

------------------------------------------------------------
------------------ All State definitions -------------------
------------------------------------------------------------

--Falling to perfourm a ground pound
states[S_POUND_FALL] = {
	sprite = SPR_PLAY,
	frame = SPR2_POFA,
	tics = 2*TICRATE,
    action = A_POUND_FALL,
    var1 = -20*FRACUNIT,
    nextstate = S_PLAY_FALL
}

--Falling to perfourm a ground pound
states[S_POUND_GROUND] = {
	sprite = SPR_PLAY,
	frame = SPR2_POGR,
	tics = TICRATE/2,
    action = A_POUND_GROUND,
    nextstate = S_PLAY_STND
}

--State of shooting bullets 
states[S_WEAPON_STANCE] = {
	sprite = SPR_PLAY,
	frame = SPR2_BUSN,
	tics = TICRATE,
    action = A_BULLET_STANCE,
    nextstate = S_PLAY_STND
}

states[S_CLIMBING] = {
    sprite = SPR_PLAY,
	frame = SPR2_RIDE,
	tics = -1,
    action = A_CLIMBING,
    nextstate = S_PLAY_JUMP
}

states[S_WALL_LEAP] = {
    sprite = SPR_PLAY,
	frame = SPR2_LEAP|A,
	tics = TICRATE/2,
    nextstate = S_PLAY_FALL
}

--Jazz's Car mode: Pontiac Solstice
states[S_PONTIAC_MODE] = {
	sprite = SPR_PLAY,
	frame = SPR2_PONT,
	tics = -1
}

--Starscream's Jet mode: F-22 Raptor
states[S_F22_MODE] = {
	sprite = SPR_PLAY,
	frame = SPR2_F22_|A,
	tics = -1
	-- action = A_PlaySound,
	-- var1 = sfx_whoosh,
	-- var2 = 1,
	-- nextstate = S_TF_F2_ST
}

-- Transforming Jazz into a Pontiac Solstice Car Alt mode
states[S_TF_JA_PON] = {
	sprite = SPR_PLAY,
    frame = SPR2_JA_T|FF_ANIMATE|A,
	tics = TICRATE/2,
	action = A_TF_JA_PON,
	var1 = 4,
	var2 = (TICRATE/2)/4,
	nextstate = S_PONTIAC_MODE -- Morph into pontial after transformation sequence
}

-- Transforming Jazz from a Pontiac Solstice Car Alt mode
states[S_TF_PON_JA] = {
	sprite = SPR_PLAY,
	frame = SPR2_T_JA|FF_ANIMATE|A,
	tics = states[S_TF_JA_PON].tics,
	action = A_TF_PON_JA,
    var1 = states[S_TF_JA_PON].var1,
    var2 = states[S_TF_JA_PON].var2,
	nextstate = S_PLAY_FALL
}

-- Deprecated?
states[S_TF_PON_JA_BR] = {
    sprite = SPR_PLAY,
	frame = SPR2_TFBR|FF_ANIMATE|A,
	tics = TICRATE,
	action = A_TF_PON_JA_BR,
    var1 = 7,
    var2 = TICRATE/15,
	nextstate = S_PLAY_WALK
}


--Transforming Starscream to a F22 Raptor Jet Alt mode
states[S_TF_ST_F2] = {
	sprite = SPR_PLAY,
	frame = SPR2_JUMP,
	tics = TICRATE/2,
	action = A_TF_ST_F2,
	nextstate = S_F22_MODE
}


--Transforming Starscream from a F22 Raptor Jet Alt mode
states[S_TF_F2_ST] = {
	sprite = SPR_PLAY,
	frame = SPR2_JUMP,
	tics = TICRATE/2,
	action = A_TF_F2_ST,
	nextstate = S_PLAY_FALL
}


--Jumps the visual out of the player when mag is empty (purely visual)
states[S_EMPTY_MAG_VISUAL] = {
    sprite = SPR_EMPT,
    frame = A,
	tics = TICRATE/2
}

-- Projectile: Blast that is shot
states[S_BLAST_SHOT] = {
	sprite = SPR_BLST,
    frame = A|FF_SEMIBRIGHT|TR_TRANS90,
	tics = 10*TICRATE
}

-- Projectile: The explosion of the blast
states[S_BLAST_EXPLODE] = {
	sprite = SPR_BLST,
    frame = A|FF_TRANS90,
    action = A_BLAST_EXPLODE,
	tics = TICRATE/3
}

-- Projectile: The dust explosion of the blast
states[S_BLAST_DUST] = {
	sprite = SPR_BLST,
    frame = A|FF_TRANS50|FF_FULLDARK,
	tics = states[S_BLAST_EXPLODE].tics/2
}


-- Projectile: Bullet that is shot
states[S_BULL_SHOT] = {
	sprite = SPR_BULL,
    frame = A|FF_SEMIBRIGHT,
	tics = TICRATE
}

-- The regular tire trace 
states[S_TRCK] = {
	sprite = SPR_TRCK,
    frame = A,
	tics = 10*TICRATE,
    nextstate = S_NULL
}

-- The regular tire trace 
states[S_FIRE] = {
	sprite = SPR_SFLM,
    frame = A,
	tics = 10,
    nextstate = S_NULL
}


-- Makes the crack appear on the wall when climbing
states[S_APPEAR] = {
	sprite = SPR_CRCK,
    frame = A,
	tics = 10*TICRATE,
    nextstate = S_NULL
}

-- The regular tire trace 
states[S_WAVE_DISTRIBUTE] = {
	sprite = SPR_WAVE,
    action = A_WAVE_DISTRIBUTE,
    frame = AFF_ANIMATE,
    var1 = 2,
    var2 = 2,
	tics = 10,
    nextstate = S_NULL
}

-- The regular tire trace 
states[S_FLAME_FOLLOW] = {
	sprite = SPR_POFL,
    -- action = A_FLAME_FOLLOW,
    frame = FF_ANIMATE|TR_TRANS20,
    var1 = 2,
    var2 = 5,
	tics = 7,
    nextstate = S_FLAME_FOLLOW
}


------------------------------------------------------------
----------------- All Objects definitions ------------------
------------------------------------------------------------

--The wave generated by the ground pound
mobjinfo[MT_POFL] = {
    spawnstate = S_FLAME_FOLLOW,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    flags = MF_SCENERY,
}

--The wave generated by the ground pound
mobjinfo[MT_CRCK] = {
    spawnstate = S_APPEAR,
    radius = FRACUNIT,
    height = FRACUNIT,
    flags = MF_SCENERY|MF_NOGRAVITY|MF_PAPERCOLLISION
}

--The wave generated by the ground pound
mobjinfo[MT_WAVE] = {
    spawnstate = S_WAVE_DISTRIBUTE,
    radius = 50*FRACUNIT,
    height = 20*FRACUNIT,
    flags = MF_SCENERY|MF_NOGRAVITY
}

--Empty mag 
mobjinfo[MT_EMPT] = {
    spawnstate = S_EMPTY_MAG_VISUAL,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    flags = MF_NOGRAVITY,
    -- flags = MF_SCENERY
}

--Tire Traces
mobjinfo[MT_TRCK] = {
    spawnstate = S_TRCK,
    radius = 13*FRACUNIT,
    height = 7*FRACUNIT,
    flags = mobjinfo[MT_SPINDUST].flags
}

--Tire fire 
mobjinfo[MT_FIRE] = {
    spawnstate = S_FIRE,
    radius = 13*FRACUNIT,
    height = 7*FRACUNIT,
    flags = mobjinfo[MT_TRCK].flags|MF_FIRE
}

--The dust effect after Crescent explosion
mobjinfo[MT_BDST] = {
    spawnstate = S_BLAST_DUST,
    flags = MF_SCENERY|MF_NOGRAVITY
}


--Heavy blast
mobjinfo[MT_WBLS] = {
    spawnstate = S_BLAST_SHOT,
    deathstate = S_BLAST_EXPLODE,
    deathsound = sfx_expld,
    speed = 90*FRACUNIT,
    radius = 16*FRACUNIT,
    height = 16*FRACUNIT,
    damage = 2,
    flags = MF_MISSILE|MF_RUNSPAWNFUNC|MF_NOGRAVITY
}

--[[
--Explosion caused by the blast
mobjinfo[MT_EXPL] = {
    spawnstate = S_BLAST_SHOT,
    speed = 70*FRACUNIT,
    radius = 32*FRACUNIT,
    height = 32*FRACUNIT,
    damage = 2,
    flags = MF_MISSILE|MF_GRENADEBOUNCE|MF_NOGRAVITY
}
]]--


--A bullet
mobjinfo[MT_WBUL] = {
    spawnstate = S_BULL_SHOT,
    speed = 100*FRACUNIT,
    radius = 10*FRACUNIT,
    height = 10*FRACUNIT,
    damage = 1,
    flags = MF_MISSILE|MF_NOGRAVITY
}

states[S_ROCKET_EXPLOSION] = {
	sprite = SPR_BMNB,
	tics = 0,
	nextstate = S_BIGMINE_BLAST1
}

mobjinfo[MT_STARSCREAM_ROCKET] = {
	spawnstate = S_TORPEDO,
	deathstate = S_ROCKET_EXPLOSION,
	xdeathstate = S_ROCKET_EXPLOSION,
	deathsound = sfx_s3k4e,
	seesound = sfx_brakrl,
	atacksound = sfx_brakrx,
	height = 5*FRACUNIT,
	radius = 5*FRACUNIT,
	damage = 1,
	speed = 50*FRACUNIT,
	flags = MF_NOGRAVITY|MF_MISSILE|MF2_SCATTER
}




--------------- THE REST --------------

-- -- local walk_cap = 20
-- addHook("PlayerThink",
-- 		function(player)
-- 			-- print("H: "..P_GetPlayerHeight(player))
-- 			-- print("S: "..P_GetPlayerSpinHeight(player))
-- 			if(not player or
-- 			not player.mo or
-- 			player.mo.skin ~= "starscream") then
-- 				return
-- 			end
			
-- 			tryTransform(player)
-- 			endSounds(player)

-- 			-- print("clinging: "..player.mo.cling)

-- 			player.mo.fuel_countdown = FUEL_CAP

-- 			-- If player is a jet
-- 			if(player.mo.state == S_F22_MODE) then
-- 				player.mo.fuel_countdown = $-1*FRACUNIT -- decrease fuel in jet mode
-- 				--[[
-- 				if(player.mo.fuel_countdown <= 0*TICRATE) then
-- 					player.mo.state = S_TF_F2_ST -- force to bot
-- 					player.mo.fuel_countdown = FUEL_CAP -- reset fuel to max
-- 				end
-- 				]]--
-- 			-- If player is a bot
-- 			elseif(player.mo.state == S_TF_ST_F2) then 
-- 				player.mo.fuel_countdown = FUEL_CAP 		-- reset to max fuel
-- 				player.mo.allow_ja_tfbjet = false			-- not allow to tf into jet
-- 			end
			
-- 			-- Don't allow botjet tranformation if
-- 			if(not player.mo.allow_ja_tfbjet and 		-- transformation is already not allowed
-- 			player.mo.eflags & MFE_JUSTHITFLOOR) then	-- object is falling
-- 				player.mo.allow_ja_tfbjet = true
-- 			end
			
-- 			--[[
-- 			-- Transform into bot if ..
-- 			if(player.mo.state == S_F22_MODE and player.mo.eflags & MFE_UNDERWATER) then -- jet submerged under water
-- 				player.mo.state = S_TF_F2_ST
-- 			end
			
-- 			-- Transform into bot if being forced from the jet mode (jet state)
-- 			if(player.mo.prevstate ~= nil and
-- 			player.mo.prevstate == S_F22_MODE and
-- 			player.mo.state ~= S_F22_MODE and
-- 			player.mo.state ~= S_TF_F2_ST) then
-- 				player.mo.state = S_TF_F2_ST
-- 			end
-- 			]]--
-- 			-- Countdowns the transformation cooldown
-- 			if(player.mo.tf_countdown > 0*TICRATE) then
-- 				player.mo.tf_countdown = $-1*TICRATE
-- 			end
-- 			-- Countdown the rocket launch cooldown
-- 			if(player.mo.missile_countdown > 0*TICRATE) then
-- 				player.mo.missile_countdown = $-1*TICRATE
-- 			end
			
-- 			-- Updates previous state
-- 			player.mo.prevstate = player.mo.state
-- 			player.lastlinehit = -1
-- 			--Update it in case clinging has topped
-- 			-- player.mo.cling = 0
-- 		end)
		
-- -- Executes each time the player is blocked by solid objects (not entities)
-- addHook("MobjMoveBlocked", 
-- 		function(player_mo, thing, line)
-- 			if(not Valid(player_mo, "starscream") or line == nil) then
-- 				return
-- 			end

-- 			--Alerting that starscream is supposed to be clinging right now
-- 			if(player_mo.prevstate == S_F22_MODE and not P_IsObjectOnGround(player_mo) and line.flags&ML_NOCLIMB == 0) then
-- 				player_mo.cling = 1
-- 			end
-- 		end,
-- 		MT_PLAYER)


-- -- Spin is pressed 
-- addHook("SpinSpecial", 
-- 		function(player)
-- 			if(player == nil or
-- 			player.mo == nil or
-- 			player.mo.skin ~= "starscream") then
-- 				return
-- 			end
			
-- 			--Launch a missle
-- 			if(player.mo.missile_countdown <= 0) then
-- 				P_SPMAngle(player.mo, MT_STARSCREAM_ROCKET, player.mo.angle)
-- 				player.mo.missile_countdown = MISSILE_TIMER_MAX
-- 			end
-- 		end,
-- 		MT_PLAYER)
